#include <fstream>
#include <iostream>
#include <sstream>
using namespace std;

int main (int argc, char * const argv[]) {
    std::cout << "This is the Ionization data library.... \n";
	const int numberOfLines = 110;
	int part, Z, shell, i, lAvail, mAvail;
	float E_min, E_max;
	char Eaux[50], xsaux[50];
	string prt, kmod,lmod, mmod,relativePath,absolutePath,path,temp;
	bool answerOk;
	kmod= "no";
	lmod= "no";
	mmod= "no";
	double E[numberOfLines][11], xs[numberOfLines][11];
	int Model[3] ={0,0,0};
	answerOk=false;
//user requirements    
	while (!answerOk) {
		std::cout << "Enter the particle type (proton[1], alpha[2]): "; 
		std::cin  >> part;
		if (part>0 && part <=2 ) answerOk=true;
	}
	answerOk=false;
	while (!answerOk) {
		std::cout << "Enter element Z number [1..92]: "; 
		std::cin  >> Z;
		if (Z>0 && Z <=92 ) answerOk=true;
	}
	answerOk=false;
	while (!answerOk) {
		std::cout << "Enter Min Energy Range [0..10000 MeV]: ";
		std::cin  >> E_min;
		if (E_min>=0 && E_min <=10000 ) answerOk=true;
	}
	answerOk=false;
	while (!answerOk) {
		std::cout << "Enter Max Energy Range [0..10000 MeV]: ";
		std::cin  >> E_max;
		if (E_max>=E_min && E_max <=10000 ) answerOk=true;
	}
	answerOk=false;
	while (!answerOk) {
		std::cout << "Shell (K[1], L[2], K+L[3], M[4], K+M[5], L+M[6], all[7]): ";
		std::cin  >> shell;
		if (shell>0 && shell <=7 ) answerOk=true;
	}
	std::cout << "\n Choose Cross Section Model.\n";
	if (part==1) {	
		if (shell==1||shell==3||shell==5||shell==7)
		{answerOk=false;
			while (!answerOk) {
				std::cout << "\n K shell model.\n ecpssr[1], ecpssr_he[2], ecpssr_hs[3], ecpssr_paul[4], ecpssr_ua[5], kahoul[6], paul [7], pwba[8]: " ;
				std::cin >> Model[0];
				if (Model[0]>0 && Model[0] <=8 ) answerOk=true;
			}
			switch (Model[0]) {
				case 1:
					kmod="ecpssr";
					break;
				case 2:
					kmod= "ecpssr_he";
					break;
				case 3:
					kmod= "ecpssr_hs";
					break;
				case 4:
					kmod= "ecpssr_paul";
					break;
				case 5:
					kmod= "ecpssr_ua";
					break;
				case 6:
					kmod= "kahoul";
					break;
				case 7:
					kmod= "paul";
					break;
				case 8:
					kmod= "pwba";
					break;
			}}
		if (shell==2||shell==3||shell==6||shell==7)
		{answerOk=false;
			while (!answerOk) {
				std::cout <<"\n L shell model.\n ecpssr[1], ecpssr_ua[2], miyagawa[3], orlic[4], pwba[5], sow[6]: "; 
				std::cin >> Model[1];
				if (Model[1]>0 && Model[1] <=6 ) answerOk=true;
			}
			switch (Model[1]) {
				case 1:
					lmod="ecpssr";
					break;
				case 2:
					lmod= "ecpssr_ua";
					break;
				case 3:
					lmod= "miyagawa";
					break;
				case 4:
					lmod= "orlic";
					break;
				case 5:
					lmod= "pwba";
					break;
				case 6:
					lmod= "sow";
					break;
				
			}}
		if (shell==4||shell==5||shell==6||shell==7)
		{answerOk=false;
			while (!answerOk) {
				std::cout <<"\n M shell model.\n ecpssr[1], pwba[2]: " ;
				std::cin >> Model[2];
				if (Model[2]>0 && Model[2] <=2 ) answerOk=true;
			}
			switch (Model[2]) {
				case 1:
					mmod="ecpssr";
					break;
				case 2:
					mmod= "pwba";
					break;
			}
		}
	}
	if (part==2) {	
	    if (shell==1||shell==3||shell==5||shell==7)
		{answerOk=false;
			while (!answerOk) {
				std::cout << "\n K shell model.\n ecpssr[1], ecpssr_hs[2], ecpssr_paul[3], paul[4], pwba[5]: "; 
				std::cin >> Model[0];
				if (Model[0]>0 && Model[0] <=5 ) answerOk=true;
			}
				switch (Model[0]) {
					case 1:
						kmod="ecpssr";
						break;
					case 2:
						kmod= "ecpssr_hs";
						break;
					case 3:
						kmod= "ecpssr_paul";
						break;
					case 4:
						kmod= "paul";
						break;
					case 5:
						kmod= "pwba";
						break;
				}
			}
		if (shell==2||shell==3||shell==6||shell==7)
		{answerOk=false;
			while (!answerOk) {
				std::cout <<"\n L shell model.\n ecpssr[1], pwba[2]: "; 
				std::cin >> Model[1];	
				if (Model[1]>0 && Model[1] <=2 ) answerOk=true;
			}
			switch (Model[1]) {
					case 1:
						lmod="ecpssr";
						break;
					case 2:
						lmod= "pwba";
						break;
				}
			}
		if (shell==4||shell==5||shell==6||shell==7)
		{answerOk=false;
			while (!answerOk) {
				std::cout <<"\n M shell model.\n ecpssr[1], pwba[2]: "; 
				std::cin >> Model[2];
				if (Model[2]>0 && Model[2] <=2 ) answerOk=true;
			}
				switch (Model[2]) {
					case 1:
						mmod="ecpssr";
						break;
					case 2:
						mmod= "pwba";
						break;
				}
			}
	}
	// A questo punto risulta individuata particella=es.protone, elemento es. Z=1, Shell=K
	// research of data folder 
	absolutePath="/Users/linaq/Desktop/nano5/data-library/pixe_datalib";
	if (part==1) absolutePath=absolutePath+"/proton";
	else absolutePath=absolutePath+"/alpha";
	ifstream fin;
	cout << "\n\n Files\n";
	if (Model[0]>0)
	{
		stringstream temp;
		temp<<Z;
		relativePath="/k/"+kmod+"/k-"+temp.str()+".dat";
		path=absolutePath+relativePath;
		cout << path;
		fin.open(path.c_str());
		if(fin)
		{
		i=0;
		while(!fin.eof()) 
			{ 
				fin >> Eaux >> xsaux;
				if (atof(Eaux)>0 && atof(Eaux)<=10000.)
				{
				E[i][0]=atof(Eaux);
				xs[i][0]=atof(xsaux);
				i++;
				}
			}
		}
		else 
		{
			E[0][0]= -1;
		cout << " (Not available)";
		}
		fin.close();
		cout << "\n";
	}
	if (Model[1]>0)
    {
		stringstream temp;
		temp<<Z;
		relativePath="/l/"+lmod+"/l-"+temp.str()+".dat";
		path=absolutePath+relativePath;
		cout << path;
		fin.open(path.c_str());
		if(fin) 
		{
		i=0;
		while(!fin.eof()) 
		 { 
			fin >> Eaux >> xsaux;
			if (atof(Eaux)>0 && atof(Eaux)<=10000.)
			{
				E[i][1]=atof(Eaux);
				xs[i][1]=atof(xsaux);
				i++;
			}
		 }
		}
		else 
		{
			E[0][1]= -1;
			cout << " (Not available)";
		}
		fin.close();
		cout << "\n";
		relativePath="/l/"+lmod+"/l1-"+temp.str()+".dat";
		path=absolutePath+relativePath;
		cout << path;
		fin.open(path.c_str());
		i=0;
		if(fin)
		{
		while(!fin.eof()) 
			{ 
				fin >> Eaux >> xsaux;
				if (atof(Eaux)>0 && atof(Eaux)<=10000.)
				{
				E[i][2]=atof(Eaux);
				xs[i][2]=atof(xsaux);
				i++;
				}
			}
		}
		else
		{
			E[0][2]= -1;
			cout << " (Not available)";
		}
		fin.close();
		cout << "\n";
		relativePath="/l/"+lmod+"/l2-"+temp.str()+".dat";
		path=absolutePath+relativePath;
		cout << path;
		fin.open(path.c_str());
		i=0;
		if(fin)
		{
		while(!fin.eof()) 
			{ 
				fin >> Eaux >> xsaux;
				if (atof(Eaux)>0 && atof(Eaux)<=10000.)
				{
					E[i][3]=atof(Eaux);
					xs[i][3]=atof(xsaux);
					i++;
				}
			} 
		}
		else 
		{
			E[0][3]= -1;
			cout << " (Not available)";
		}
		fin.close();
		cout << "\n";
		relativePath="/l/"+lmod+"/l3-"+temp.str()+".dat";
		path=absolutePath+relativePath;
		cout << path;
		fin.open(path.c_str());
		i=0;
		if(fin)
		{
		while(!fin.eof()) 
				{ 
				fin >> Eaux >> xsaux;
				if (atof(Eaux)>0 && atof(Eaux)<=10000.)
					{
					E[i][4]=atof(Eaux);
					xs[i][4]=atof(xsaux);
					i++;
					}
				}
		} else
		{
			E[0][4]= -1;
			cout << " (Not available)";
		}
		fin.close();
		cout << "\n";
	}
	if (Model[2]>0)
	{
		stringstream temp;
		temp<<Z;
		relativePath="/m/"+lmod+"/m-"+temp.str()+".dat";
		path=absolutePath+relativePath;
		cout << path;
		fin.open(path.c_str());
		i=0;
		if (fin)
		{
			while(!fin.eof()) 
			{ 
				fin >> Eaux >> xsaux;
				if (atof(Eaux)>0 && atof(Eaux)<=10000.)
				{
					E[i][5]=atof(Eaux);
					xs[i][5]=atof(xsaux);
					i++;
				}
			}
		}
		else
		{
			E[0][5]= -1;
			cout << " (Not available)";	
		}
		fin.close();
		cout << "\n";
		relativePath="/m/"+lmod+"/m1-"+temp.str()+".dat";
		path=absolutePath+relativePath;
		cout << path;
		fin.open(path.c_str());
		i=0;
		if (fin)
		{
		while(!fin.eof()) 
			{ 
			fin >> Eaux >> xsaux;
			if (atof(Eaux)>0 && atof(Eaux)<=10000.)
				{
				E[i][6]=atof(Eaux);
				xs[i][6]=atof(xsaux);
				i++;
				}
			}
		}
			else 
			{
				E[0][6]= -1;
				cout << " (Not available)";	
			}
		fin.close();
		cout << "\n";
		relativePath="/m/"+lmod+"/m2-"+temp.str()+".dat";
		path=absolutePath+relativePath;
		cout << path;
		fin.open(path.c_str());
		i=0;
		if (fin)
		{
			while(!fin.eof()) 
			{ 
				fin >> Eaux >> xsaux;
				if (atof(Eaux)>0 && atof(Eaux)<=10000.)
				{
				E[i][7]=atof(Eaux);
				xs[i][7]=atof(xsaux);
				i++;
				}
			}
		}
		else
		{
			E[0][7]= -1;
			cout << " (Not available)";
		}
		fin.close();
		cout << "\n";
		relativePath="/m/"+lmod+"/m3-"+temp.str()+".dat";
		path=absolutePath+relativePath;
		cout << path;
		fin.open(path.c_str());
		i=0;
		if(fin)
		{
		while(!fin.eof()) 
			{ 
				fin >> Eaux >> xsaux;
				if (atof(Eaux)>0 && atof(Eaux)<=10000.)
				{
				E[i][8]=atof(Eaux);
				xs[i][8]=atof(xsaux);
				i++;
				}
			}
		}
		else
		{
			E[0][8]= -1;
			cout << " (Not available)";
		}
		fin.close();
		cout << "\n";
		relativePath="/m/"+lmod+"/m4-"+temp.str()+".dat";
		path=absolutePath+relativePath;
		cout << path;
		fin.open(path.c_str());
		i=0;
		if (fin)
		{
		while(!fin.eof()) 
			{ 
			fin >> Eaux >> xsaux;
			if (atof(Eaux)>0 && atof(Eaux)<=10000.)
				{
				E[i][9]=atof(Eaux);
				xs[i][9]=atof(xsaux);
				i++;
				}
			}
		}
		else
		{
			E[0][9]= -1;
			cout << " (Not available)";		
		}
		fin.close();
		cout << "\n";
		relativePath="/m/"+lmod+"/m5-"+temp.str()+".dat";
		path=absolutePath+relativePath;
		cout << path;
		fin.open(path.c_str());
		if(fin)
		{
		i=0;
		while(!fin.eof()) 
			{ 
			fin >> Eaux >> xsaux;
			if (atof(Eaux)>0 && atof(Eaux)<=10000.)
				{
				E[i][10]=atof(Eaux);
				xs[i][10]=atof(xsaux);
				i++;
				}
			}
		}
		else
		{
			E[0][10]= -1;
			cout << " (Not available)";		
		}
		fin.close();
		cout << "\n";
	}
	// printout
	if (part==1) prt="proton";
	if (part==2) prt="alpha";
	cout<<"-----------------------------------------------------------------------------------------------\n"<< "Particle = "<< prt<<" |  Element: Z = "<<Z;
	if (kmod!="no") cout<< " | K model = "<< kmod;
	if (lmod!="no") cout<< " | L model = "<< lmod;
	if (mmod!="no") cout<< " | M model = "<< mmod;
	cout<<"\n-----------------------------------------------------------------------------------------------";
	if (kmod!="no") cout<< "\n\nEnergy [MeV]          " << " | K Cross-Section [mb]";
	cout<< "\n\n";
	if (Model[0]>0)
	{
		if (E[0][0]==-1) 
		{
			cout << "\n\nCross sections not available for this configuration\n";
		} else
		{
			for (i=0; E[i][0]<= E_max; i++) 
			{
				if (E[i][0]>=E_min) 
					if (E[i][0]>E[i-1][0])
				{	
					cout.width(22);
					cout<<  E[i][0];
					cout.width(23);
					cout <<xs[i][0]<<"\n";
				}
				else if (i==0) 
					{
						cout.width(22);
						cout<<  E[0][0];
						cout.width(23);
						cout <<xs[0][0]<<"\n";
					}
			}
		}	
	}
	if (Model[1]>0)
	{
		cout << "\n----------------------------------------------------------------------------------------------------------------------";
		cout << "\nEnergy [MeV]          "<< " |  L Cross-Section [mb]"<< " | L1 Cross-Section [mb]"<< " | L2 Cross-Section [mb]"<< " | L3 Cross-Section [mb]" ;
		cout << "\n----------------------------------------------------------------------------------------------------------------------\n";
	    lAvail=0;
		for (int j=1; j<=4; j++) {
			if (E[0][j]!=-1) {
				lAvail=j;
				break;
			}
		}
		if (lAvail==0) {
			cout << "\n\nCross sections not available for this configuration\n";
		} else
		{
			for (i=0; E[i][lAvail]<= E_max; i++) 
		{
			if (E[i][lAvail]>=E_min) 
				if (E[i][lAvail]>E[i-1][lAvail])
				{
					cout.width(22);
					cout<<  E[i][lAvail];
					cout.width(24);
					if (E[0][1]!=-1) cout <<xs[i][1];
					else cout <<"N/A";
					cout.width(24);
					if (E[0][2]!=-1) cout <<xs[i][2];
					else cout <<"N/A";
					cout.width(24);
					if (E[0][3]!=-1) cout <<xs[i][3];
					else cout <<"N/A";
					cout.width(24);
					if (E[0][4]!=-1) cout <<xs[i][4]<<"\n";
					else cout <<"N/A"<<"\n";				
				}
				else if (i==0) 
				{
					cout.width(22);
					cout<<  E[0][lAvail];
					cout.width(24);
					if (E[0][1]!=-1) cout <<xs[0][1];
					else cout <<"N/A";
					cout.width(24);
					if (E[0][2]!=-1) cout <<xs[0][2];
					else cout <<"N/A";
					cout.width(24);
					if (E[0][3]!=-1) cout <<xs[0][3];
					else cout <<"N/A";
					cout.width(24);
					if (E[0][4]!=-1) cout <<xs[0][4]<<"\n";
					else cout <<"N/A"<<"\n";				
				}
			}
		}
	 }
	if (Model[2]>0)
	{
		cout << "\n----------------------------------------------------------------------------------------------------------------------------------------------------------------------";
		cout <<  "\nEnergy [MeV]           "<<"|  M Cross-Section [mb]"<< " | M1 Cross-Section [mb]"<< " | M2 Cross-Section [mb]"<< " | M3 Cross-Section [mb]"<< " | M4 Cross-Section [mb]"<< " | M5 Cross-Section [mb]";
		cout << "\n----------------------------------------------------------------------------------------------------------------------------------------------------------------------\n";
		mAvail=0;
		for (int j=5; j<=10; j++) {
			if (E[0][j]!=-1) {
				mAvail=j;
				break;
			}
		}
		if (mAvail==0) {
			cout << "\n\nCross sections not available for this configuration\n";
		} else
		{		
		for (i=0; E[i][mAvail]<= E_max; i++) 
			{
				if (E[i][mAvail]>=E_min) 
					if (E[i][mAvail]>E[i-1][mAvail])
					{	
						cout.width(22);
						cout<<  E[i][mAvail];
						cout.width(24);
						if (E[0][5]!=-1) cout <<xs[i][5];
						else cout <<"N/A";
						cout.width(24);
						if (E[0][6]!=-1) cout <<xs[i][6];
						else cout <<"N/A";
						cout.width(24);
						if (E[0][7]!=-1) cout <<xs[i][7];
						else cout <<"N/A";
						cout.width(24);
						if (E[0][8]!=-1)  cout <<xs[i][8];
						else cout <<"N/A";
						cout.width(24);
						if (E[0][9]!=-1)  cout <<xs[i][9];
						else cout <<"N/A";
						cout.width(24);
						if (E[0][10]!=-1)  cout <<xs[i][10]<<"\n";
						else cout <<"N/A"<<"\n";
					}
				else if (i==0);
				{	
					cout.width(22);
					cout<<  E[0][mAvail];
					cout.width(24);
					if (E[0][5]!=-1) cout <<xs[0][5];
					else cout <<"N/A";
					cout.width(24);
					if (E[0][6]!=-1) cout <<xs[0][6];
					else cout <<"N/A";
					cout.width(24);
					if (E[0][7]!=-1) cout <<xs[0][7];
					else cout <<"N/A";
					cout.width(24);
					if (E[0][8]!=-1)  cout <<xs[0][8];
					else cout <<"N/A";
					cout.width(24);
					if (E[0][9]!=-1)  cout <<xs[0][9];
					else cout <<"N/A";
					cout.width(24);
					if (E[0][10]!=-1)  cout <<xs[0][10]<<"\n";
					else cout <<"N/A"<<"\n";
				}
			}
		}
	}
	return 0;
}